# HTML2scribe.py
# author: Bastian Appenzeller
# 
# This script is part of HTML2scribe. For further information like license read HTML2scribe.txt

from sys import argv
from string import strip


def breakArticle(actArticle):
	"breaks an article into lines of 33 characters"
	returnLine = ""

	while len(actArticle) > 33:
		lastWord = actArticle[:33].rfind(" ")
		lastMinus = actArticle[:33].rfind("-")
		lastSlash = actArticle[:33].rfind(r"/")
		lastCharInLine = max(lastWord, lastMinus, lastSlash)
		if lastCharInLine == -1:
			returnLine += actArticle[:32] + ".\n"
			newactArticle = actArticle[33:]
			actArticle = newactArticle[newactArticle.find(" "):]
		else:
			returnLine += (actArticle[:lastCharInLine+1]).strip() + "\n"
			actArticle = actArticle[lastCharInLine+1:]
	returnLine += actArticle
	return returnLine


def extractText(filename):
	"extracts only wanted text"

	# reads unwanted lines of criteria.txt
	criteria = []
	criteriaFile = open("criteria.txt", "r")
	for actLine in criteriaFile:
		if not actLine.startswith("#"):
			criteria.append(actLine[:-1])
	criteriaFile.close()

	# reads data of html2txt.webl and extracts text to a scribe data file
	makeHeader = 0									# 1 = next will be a header, 0 = next will be text
	firstHeader = 1									# 1 = first time a header apperas
	story = ""
	
	news = open(filename, 'r')
	scribenews = open(filename[:-4] +".df", 'w')
	scribenews.write("%%HP: T(1)A(D)F(.);\n{\n\"")	# begin of a scribe data file

	for actLine in news:
		if not actLine.isspace() and type(actLine) <> None:
			criteriaOK = 1 # 0 = not OK, 1 = OK
			for actCriteria in criteria:
				if actLine.startswith(actCriteria[:25]):
					criteriaOK = 0
			if criteriaOK == 1:

				# replace characters not existing on the HP48
				actLine = actLine.replace("", "oe")
				actLine = actLine.replace("", "Oe")
				actLine = actLine.replace("", "ue")
				actLine = actLine.replace("", "Ue")
				actLine = actLine.replace("", "ae")
				actLine = actLine.replace("", "Ae")
				actLine = actLine.replace("&szlig;", "ss")
				actLine = actLine.replace("&uuml;", "ue")
				actLine = actLine.replace("&Uuml;", "Ue")
				actLine = actLine.replace("&ouml;", "oe")
				actLine = actLine.replace("&Ouml;", "Oe")
				actLine = actLine.replace("&auml;", "ae")
				actLine = actLine.replace("&Auml;", "Ae")
				actLine = actLine.replace("&quot;", "'")
				actLine = actLine.replace("\"", "'")
				actLine = actLine.replace("&#150", "")		# -
				actLine = actLine.replace("&nbsp;", "")	# picture
				actLine = actLine.replace("&eacute;", "e")	# french Akzent ber e
				
				if makeHeader == 1:
					headerEnd = actLine[:21].rfind(" ")	# header could have a maximum of 21 characters
					if headerEnd == -1:
						headerEnd = 20
					scribenews.write(actLine[:headerEnd] + "\n")
					scribenews.write(breakArticle((actLine[:-1].strip()) + "\n"))
					makeHeader = 0
				elif actLine == "---new scribe entry---\n":
					if firstHeader <> 1:
						scribenews.write(breakArticle(story) + "\"\n\"")
					else:
						firstHeader = 2
					story = ""
					makeHeader = 1
				else:
					story += (actLine[:-1].strip()) + " "	
	news.close()
	scribenews.write(breakArticle(story) + "\"\n}")	
	scribenews.close()
	
if __name__ == '__main__':
	extractText(argv[1])
